// Csv2CavistDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Csv2Cavist.h"
#include "Csv2CavistDlg.h"

#include "..\cavist\pbottle.h"

#include "pdatabasefile.h"
#include "PBottleMapper.h"
#include "PCsvFileManager.h"
#include "pmembuffer.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
CCsv2CavistDlg* dlg;
void logLine(const char* line)
{
	dlg->logLine(line);
}
void logLine(const CString& line)
{
	dlg->logLine(line);
}

/////////////////////////////////////////////////////////////////////////////
// CCsv2CavistDlg dialog

CCsv2CavistDlg::CCsv2CavistDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCsv2CavistDlg::IDD, pParent),
	fieldsMapper_(0),
	recordNumber_(0)
{
	//{{AFX_DATA_INIT(CCsv2CavistDlg)
	//m_PdbFileName = _T("C:\\WINNT\\Profiles\\jec\\Desktop\\wine.pdb");
  m_PdbFileName = _T("e:\\test\\cavist\\bottles.pdb");
	//m_CsvFileName = _T("C:\\WINNT\\Profiles\\jec\\Desktop\\wine.csv");
  m_CsvFileName = _T("e:\\test\\cavist\\bottles.txt");
	m_LanguageStatic = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	dlg = this;
}

void CCsv2CavistDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCsv2CavistDlg)
	DDX_Control(pDX, IDC_EVENT_LIST, m_EventList);
	DDX_Text(pDX, IDC_PDB_FILE_NAME_EDIT, m_PdbFileName);
	DDX_Text(pDX, IDC_CSV_FILE_NAME_EDIT, m_CsvFileName);
	DDX_Text(pDX, IDC_LANGUAGE, m_LanguageStatic);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCsv2CavistDlg, CDialog)
	//{{AFX_MSG_MAP(CCsv2CavistDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PDB_BROWSE_BUTTON, OnPdbBrowseButton)
	ON_BN_CLICKED(IDC_CSV_BROWSE_BUTTON, OnCsvBrowseButton)
	ON_BN_CLICKED(IDC_CSV2PDB_BUTTON, OnCsv2pdbButton)
	ON_BN_CLICKED(IDC_PDB2CSV_BUTTON, OnPdb2csvButton)
	ON_COMMAND(IDC_ABOUT, OnAbout)
	ON_COMMAND(IDC_ENGLISH, OnEnglish)
	ON_COMMAND(IDC_FRENCH, OnFrench)
	ON_COMMAND(IDC_QUIT, OnQuit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void* MemCopy(void* dest, const void* src, long len)
{
	return memcpy(dest, src, len);
}


/////////////////////////////////////////////////////////////////////////////
// CCsv2CavistDlg message handlers
BOOL CCsv2CavistDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	PBottleMapper::init();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	OnFrench();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCsv2CavistDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCsv2CavistDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//-------------------------------------------------------------
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCsv2CavistDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//-------------------------------------------------------------
void CCsv2CavistDlg::OnPdbBrowseButton() 
{
	CFileDialog dlg(TRUE, "", NULL);
	dlg.DoModal();

	m_PdbFileName = dlg.GetPathName();
	UpdateData(FALSE);
}

//-------------------------------------------------------------
void CCsv2CavistDlg::OnCsvBrowseButton() 
{
	CFileDialog dlg(TRUE, "", NULL);
	dlg.DoModal();

	m_CsvFileName = dlg.GetPathName();
	UpdateData(FALSE);
}









//-------------------------------------------------------------
// OK
void CCsv2CavistDlg::OnCsv2pdbButton() 
{
	PBottleMapper::setLanguage(m_Language);

	UpdateData(TRUE);
	m_EventList.ResetContent();

	if (m_CsvFileName == "")
    {
		logLine("The name for the CSV file is not set");
        return;
    }

	recordNumber_ = 0;
	if (m_PdbFileName == "")
	{
		m_PdbFileName = m_CsvFileName;
		int index = m_PdbFileName.ReverseFind('.');
		CString temp = m_PdbFileName.Left(index);
		m_PdbFileName = temp + ".pdb";
	}


	PCollection coll(removeBottle, 0);
	if (!createBottlesFromCsv(coll, m_CsvFileName))
		return;



	if (!createPdbFromBottles(coll, m_PdbFileName))
		return;

	logLine("OK, that's done.");
}









//-------------------------------------------------------------
// OK
void CCsv2CavistDlg::OnPdb2csvButton() 
{
	PBottleMapper::setLanguage(m_Language);
	m_EventList.ResetContent();

    if (m_PdbFileName == "")
    {
		logLine("The name for the PDB file is not set");
        return;
    }


	PCollection coll(removeBottle, 0);

	if (m_CsvFileName == "")
	{
		m_CsvFileName = m_PdbFileName;
		int index = m_CsvFileName .ReverseFind('.');
		CString temp = m_CsvFileName .Left(index);
		m_CsvFileName = temp + ".pdb";
	}

	
	if (!createBottlesFromPdb(coll, m_PdbFileName ))
  {
    logLine("Error while reading from PDB file! Aborting");
		return;
  }

    
	if ( !createCsvFromBottles(coll, m_CsvFileName) )
  {
    logLine("Error while creating CSV file! Aborting");
		return;
  }


  logLine("OK, all right.");
}











//-------------------------------------------------------------
// OK
BOOL CCsv2CavistDlg::createBottlesFromPdb(PCollection& coll, const CString& fileName)
{
	PDatabaseFile db;

	PString name = fileName;
	
	if (!db.read(coll, name))
		return false;

	return true;
}











//-------------------------------------------------------------
// OK
BOOL CCsv2CavistDlg::createBottlesFromCsv(PCollection& coll, const CString& fileName)
{

	PCsvFileManager csvFile;
	PString name = fileName;
	if (!csvFile.open( name ))
	{
		MessageBox("Can't open the CSV file");
		return false;
	}

	

	CStringArray line;

	// The first line
	csvFile.getNextLine(line);
	nbFields_ = line.GetSize();
    long nbFieldsOk = createMapping(line);


	CString str;
	str.Format("There is %d fields in the Bottle definition", nbFieldsOk);
	logLine(str);


	recordNumber_ = 1;
	while( csvFile.getNextLine(line) )
	{
		if (nbFieldsOk != line.GetSize())
		{
			CString str;
			str.Format("There is %d values for the records #%d while waiting for %d", line.GetSize(), recordNumber_, nbFieldsOk);
			logLine(str);
		}
		else
		{
			// Add a bottle to collection
			if (!writeRecord(coll, line))
			{
				str.Format("Can't add the record #%d", recordNumber_);
				logLine(str);
			}
		}
		recordNumber_++;
	}

	return true;
}











//-----------------------------------------------------------------------
// NOK
BOOL CCsv2CavistDlg::createPdbFromBottles(PCollection& coll, const CString& fileName)
{
	// Write db
	PDatabaseFile databaseFile;
	PString name = fileName;
	if ( !databaseFile.write(coll, name) )
	{
		logLine("Can't create the PDB file");
		return false;
	}

	return true;
}
















//-----------------------------------------------------------------------
// OK
BOOL CCsv2CavistDlg::createCsvFromBottles(PCollection& coll, const CString& fileName)
{
	CStdioFile csvFile;
	if (!csvFile.Open(fileName, CFile::modeWrite | CFile::modeCreate))
	{
		logLine("Can't open the CSV file");
		return false;
	}

	
	long maxNbOfEvents = 0;
	PBottle* bottle;
    for (long i=0; i<coll.getSize(); i++)
	{
		bottle = (PBottle*)coll.getAt(i);
		if (bottle == 0)
		{
			logLine("Wrong bottle (NULL) received");
			return false;
		}
		const PCollection& journal = bottle->getJournal();
		if (journal.getSize() > maxNbOfEvents)
    {
			maxNbOfEvents = journal.getSize();
    }
	}

	dumpHeader(csvFile, maxNbOfEvents);


  for (i=0; i<coll.getSize(); i++)
	{
		bottle = (PBottle*)coll.getAt(i);
		if (bottle == 0)
		{
			logLine("Wrong bottle (NULL) received");
			return false;
		}

		dumpBottle(csvFile, *bottle);
	}

  CString str;
  str.Format("There was '%d' bottles dumped in CSV file", coll.getSize());
  logLine(str);
  return true;
}



//-------------------------------------------------------------
void CCsv2CavistDlg::logLine(const CString& line)
{
	CTime time = CTime::GetCurrentTime();
	CString str;
	str = time.Format("%H:%M:%S: ");
	str += line;

	m_EventList.InsertString(0, str);
}

//-----------------------------------------------------------------------
long CCsv2CavistDlg::createMapping(CStringArray& line)
{
	delete fieldsMapper_;
	fieldsMapper_ = new long[nbFields_];
	long i;
	for (i=0;i<nbFields_;i++)
	{
		fieldsMapper_[i] = -1;
	}

	nbFields_ = line.GetSize();
	long index, nbFieldsOk = 0;
	for (i=0;i<line.GetSize();i++)
	{
		PString str = line.GetAt(i);
		index = PBottleMapper::getIndexForTag( str );
		if (index == -1)
		{
			CString str;
			str.Format("The column '%s' can not be found. Ignoring.", line.GetAt(i));
			logLine(str);
		}
    else
    {
      nbFieldsOk++;
    }
		fieldsMapper_[i] = index;
	}

	return nbFieldsOk;
}
/*
//-------------------------------------------------------------
BOOL CCsv2CavistDlg::readChar(CFile& file, char& c)
{
	return ( file.Read(&c, 1)==1 );
}

//-------------------------------------------------------------
BOOL CCsv2CavistDlg::getNextLine(CFile& file, CStringArray& line)
{
	line.RemoveAll();

	char c;
	
	if (!goToNextSeparator(file))
		return false;


	CString token;
	BOOL eol = FALSE;
	BOOL inField = false;
	while(!eol)
	{
		if (!readChar(file, c))
			return FALSE;

		if (inField)
		{
			if (c != '"')
				token += c;
		}

		switch(c)
		{
		case '"':
			if (inField)
			{
				line.Add(token);
				token = "";
				if (!goToNextSeparator(file))
					eol = TRUE;
			}
			inField = !inField;
			break;
		case 13:
			readChar(file, c);	//10
		case 10:
			eol = TRUE;
			break;

		default:
			token += c;
			break;
		}
	}

	return TRUE;
}

//-------------------------------------------------------------
BOOL CCsv2CavistDlg::goToNextSeparator(CFile& file)
{
	BOOL eol = FALSE;
	char c;
	while(!eol)
	{
		if (!readChar(file, c))
			return FALSE;

		switch(c)
		{
		case '"':
			eol = TRUE;
			break;

		case 13:
			readChar(file, c);
		case 10:
			return FALSE;
		}
	}

	return TRUE;
}
*/
//-------------------------------------------------------------
BOOL CCsv2CavistDlg::writeRecord(PCollection& coll, CStringArray& line)
{
	PBottle* bottle = new PBottle;

	long index, i;
	
	for (i=0; i<line.GetSize(); i++)
	{
		index = fieldsMapper_[i];
		if (index != -1)
		{
			PBottleMapper::setValueInBottle(*bottle, index, PString(line.GetAt(i)) );
		}
	}

	coll.add(bottle);
	return TRUE;
}

//-------------------------------------------------------------
BOOL CCsv2CavistDlg::dumpHeader(CStdioFile& csvFile, long maxNbOfEvents)
{
	PBottleMapper::setLanguage(m_Language);

	PString str1, str2;
	for (long i=0;i<PBottleMapper::getNbFields();i++)
	{
		str2 = "";
		if (i != 0)
			str2 = ",";

		PBottleMapper::getTagForIndex(i, str1);
		str2 += "\"" + str1 + "\"";
		csvFile.WriteString(str2.data());
	}


	// Dump journal header
	PString str;
	for (i=0;i<maxNbOfEvents;i++)
	{
		str.print(",\"Date%d\",\"Note%d\"", i, i);
		csvFile.WriteString(str.data());
	}


	str2 = "\n";
	csvFile.WriteString(str2.data());
	return true;
}

//-------------------------------------------------------------
BOOL CCsv2CavistDlg::dumpBottle(CStdioFile& csvFile, PBottle& bottle)
{
	PString str;

	//csvFile.WriteString( str.data() );

	for (long i=0;i<PBottleMapper::getNbFields();i++)
	{
		PBottleMapper::getValueInBottle(bottle, i, str);

		if (i != 0) //  Not the first time
			csvFile.WriteString(",");
		csvFile.WriteString("\"");

		csvFile.WriteString(str.data());
		
		csvFile.WriteString("\"");

	}



	// Dump events



	csvFile.WriteString("\n");


	return true;
}


void CCsv2CavistDlg::OnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CCsv2CavistDlg::OnEnglish() 
{
	m_Language = e_English;

	m_LanguageStatic = "English";
	UpdateData(FALSE);
}

void CCsv2CavistDlg::OnFrench() 
{
	m_Language = e_French;

	m_LanguageStatic = "French";
	UpdateData(FALSE);
}

void CCsv2CavistDlg::OnQuit() 
{
	EndDialog(0);
}
