// Csv2CavistDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCsv2CavistDlg dialog

class PCollection;
class PDatabaseFile;
class PBottle;
class CCsv2CavistDlg : public CDialog
{
// Construction
public:
	CCsv2CavistDlg(CWnd* pParent = NULL);	// standard constructor

	void logLine(const CString& line);

// Dialog Data
	//{{AFX_DATA(CCsv2CavistDlg)
	enum { IDD = IDD_CSV2CAVIST_DIALOG };
	CListBox	m_EventList;
	CString	m_PdbFileName;
	CString	m_CsvFileName;
	CString	m_LanguageStatic;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCsv2CavistDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	HICON m_hIcon;

	
	
	BOOL createBottlesFromPdb(PCollection& coll, const CString& fileName);
	BOOL createBottlesFromCsv(PCollection& coll, const CString& fileName);
	BOOL createPdbFromBottles(PCollection& coll, const CString& fileName);
	BOOL createCsvFromBottles(PCollection& coll, const CString& fileName);



	long createMapping(CStringArray& line);

	BOOL writeRecord(PCollection& coll, CStringArray& line);

	//BOOL goToNextSeparator(CFile& csvFile);
	//BOOL getNextLine(CFile& file, CStringArray& line);
	//BOOL readChar(CFile& file, char& c);
	
	
	BOOL dumpBottle(CStdioFile& csvFile, PBottle& bottle);
	BOOL dumpHeader(CStdioFile& csvFile, long maxNbOfEvents);



	// Generated message map functions
	//{{AFX_MSG(CCsv2CavistDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnPdbBrowseButton();
	afx_msg void OnCsvBrowseButton();
	afx_msg void OnCsv2pdbButton();
	afx_msg void OnPdb2csvButton();
	afx_msg void OnAbout();
	afx_msg void OnEnglish();
	afx_msg void OnFrench();
	afx_msg void OnQuit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	long* fieldsMapper_;
	long nbFields_;
	long recordNumber_;

	enum e_Language { e_French, e_English, e_German };
	e_Language m_Language;

};
