

#include "pbottlemapper.h"
#include "../cavist/cprotos.h"
#include "PMemBuffer.h"



#define Index_Quantite			0
#define Index_Appelation		1
#define Index_Cru				2
#define Index_Type				3
#define Index_Millesime			4
#define Index_Contenance		5
#define Index_Region			6
#define Index_A_boire_des		7
#define Index_A_boire_jusqu_a	8
#define Index_Appreciation		9
#define Index_Classe			10
#define Index_Producteur		11
#define Index_Cepage			12
#define Index_Achat				13
#define Index_Lieu_d_achat		14
#define Index_Prix				15
#define Index_Casier			16
#define Index_Commentaire		17
#define Index_Event				20


PCollection		PBottleMapper::frenchTags_(removeString, 0);
PCollection		PBottleMapper::germanTags_(removeString, 0);
PCollection		PBottleMapper::englishTags_(removeString, 0);

char			PBottleMapper::language_ = 0;



void logLine(const char* data);

Boolean PBottleMapper::init()
{
	frenchTags_.add( new PString("Quantite") );
	frenchTags_.add( new PString("Appelation") );
	frenchTags_.add( new PString("Cru") );
	frenchTags_.add( new PString("Type") );
	frenchTags_.add( new PString("Millesime") );
	frenchTags_.add( new PString("Contenance") );
	frenchTags_.add( new PString("Region") );
	frenchTags_.add( new PString("A boire des") );
	frenchTags_.add( new PString("A boire jusqu'a") );
	frenchTags_.add( new PString("Appreciation") );
	frenchTags_.add( new PString("Classe") );
	frenchTags_.add( new PString("Producteur") );
	frenchTags_.add( new PString("Cepage") );
	frenchTags_.add( new PString("Date d'achat") );
	frenchTags_.add( new PString("Lieu d'achat") );
	frenchTags_.add( new PString("Prix") );
	frenchTags_.add( new PString("Casier") );
	frenchTags_.add( new PString("Commentaire") );
	
	englishTags_.add( new PString("Quantity") );
	englishTags_.add( new PString("Appelation") );
	englishTags_.add( new PString("Blend") );
	englishTags_.add( new PString("Type") );
	englishTags_.add( new PString("Vintage") );
	englishTags_.add( new PString("Capacity") );
	englishTags_.add( new PString("Region") );
	englishTags_.add( new PString("To drink from") );
	englishTags_.add( new PString("To drink to") );
	englishTags_.add( new PString("Rating") );
	englishTags_.add( new PString("Classification") );
	englishTags_.add( new PString("Producer") );
	englishTags_.add( new PString("Grape variety") );
	englishTags_.add( new PString("Purchase") );
	englishTags_.add( new PString("Purchase by") );
	englishTags_.add( new PString("Price") );
	englishTags_.add( new PString("Rack") );
	englishTags_.add( new PString("Note") );

	return true;
}

long PBottleMapper::getNbFields()
{
	return frenchTags_.getSize();
}

PCollection& PBottleMapper::getMlCollection()
{
	if (language_ == 0)
		return frenchTags_;
	else if (language_ == 1)
		return englishTags_;
	else if (language_ == 2)
		return germanTags_;

	throw 0;
	return germanTags_;
}

/*
Boolean PBottleMapper::createRecord(PBottle& bottle, PFileRecord* rec)
{
	PRecord buffer;
	buffer << bottle;

	long len =  buffer.getSize();
	char* data = new char[len];
	MemCopy(data, buffer.getData(), len);

	rec->setData(data, len);
	rec->detachData();

	return true;
}
*/

long PBottleMapper::getIndexForTag(const PString& str)
{
	long i;
	PString* pstr;
	for (i=0; i<getNbFields(); i++)
	{
		pstr = (PString*)getMlCollection().getAt(i);
		if (pstr != 0)
		{
			if (str == *pstr)
			{
				return i;
			}
		}
	}

	return -1;
}

Boolean PBottleMapper::getTagForIndex(long index, PString& str)
{
	PString* pstr;
	for (long i=0;i<getNbFields();i++)
	{
		pstr = (PString*)getMlCollection().getAt(index);
		if (pstr != 0)
		{
			str = *pstr;
			return true;
		}
	}

	return false;
}

//---------------------------------------------------------------
Boolean PBottleMapper::setValueInBottle(PBottle& bottle, long index, const PString& value)
{
	long nb;
	switch(index)
	{
	case Index_Quantite:
		{
			nb = atoi(value.data());
			bottle.setQuantite(nb);
		}
		return true;

	case Index_Appelation:
		{
			bottle.setAppelation(value);
		}
		return true;

	case Index_Cru:
		{
			bottle.setCru(value);
		}
		return true;
	case Index_Type:
		{
			bottle.setType(value);
		}
		return true;
	case Index_Millesime:
		{
			nb = atoi(value.data());
			bottle.setMillesime(nb);
		}
		return true;

	case Index_Contenance:
		{
			bottle.setContenance(value);
		}
		return true;

	case Index_Region:
		{
			bottle.setRegion(value);
		}
		return true;

	case Index_A_boire_des:
		{
			nb = atoi(value.data());
			bottle.setToDrinkMin(nb);
		}
		return true;

	case Index_A_boire_jusqu_a:
		{
			nb = atoi(value.data());
			bottle.setToDrinkMax(nb);
		}
		return true;

	case Index_Appreciation:
		{
			bottle.setAppreciation(value);
		}
		return true;

	case Index_Classe:
		{
			bottle.setClasse(value);
		}
		return true;

	case Index_Producteur:
		{
			bottle.setProducteur(value);
		}
		return true;

	case Index_Cepage:
		{
			bottle.setCepage(value);
		}
		return true;

	case Index_Achat:
		{
			PDate date;
			date.fromString(value);
			bottle.setDateAchat(date);
		}
		return true;

	case Index_Lieu_d_achat:
		{
			bottle.setLieuAchat(value);
		}
		return true;

	case Index_Prix:
		{
			bottle.setPrix(value);
		}
		return true;

	case Index_Casier:
		{
			bottle.setCasier(value);
		}
		return true;

	case Index_Commentaire:
		{
			bottle.setCommentaire(value);
		}
		return true;

	}



	// It's an event
	if (index > Index_Event)
	{
		nb = index - Index_Event;
		Boolean type = nb % 2;
		nb = (nb-type)/2;
		const PCollection& coll = bottle.getJournal();
		if (nb >= coll.getSize())
		{
			bottle.addEvent("");
		}
		if (nb >= coll.getSize())
		{
			PString str;
			str.print("The number for event '%d' is more or equal to the number in the bottle '%d'", nb, coll.getSize());
			logLine(str.data());
			return false;
		}
		PJournalEvent* event = (PJournalEvent*)coll.getAt(nb);

		if (type == 0) // date
		{
			PDate date;
			date.fromString(value);
			event->setDate(date);
		}
		else
		{
			event->setNote(value);
		}
	}

	return false;
}

//---------------------------------------------------------------
Boolean PBottleMapper::getValueInBottle(const PBottle& bottle, long index, PString& value)
{
	long nb;
	switch(index)
	{
	case Index_Quantite:
		{
			nb = bottle.getQuantite();
			value.convert(nb);
		}
		return true;

	case Index_Appelation:
		{
			value = bottle.getAppelation();
		}
		return true;

	case Index_Cru:
		{
			value = bottle.getCru();
		}
		return true;
	case Index_Type:
		{
			value = bottle.getType();
		}
		return true;
	case Index_Millesime:
		{
			nb = bottle.getMillesime();
			value.convert(nb);
            if (nb > 1900)
			    value.convert(nb);
            else
                value = "";
		}
		return true;

	case Index_Contenance:
		{
			value = bottle.getContenance();
		}
		return true;

	case Index_Region:
		{
			value = bottle.getRegion();
		}
		return true;

	case Index_A_boire_des:
		{
			nb = bottle.getToDrinkMin();
            if (nb > 1900)
			    value.convert(nb);
            else
                value = "";
		}
		return true;

	case Index_A_boire_jusqu_a:
		{
			nb = bottle.getToDrinkMax();
            if (nb > 1900)
			    value.convert(nb);
            else
                value = "";
		}
		return true;

	case Index_Appreciation:
		{
			value = bottle.getAppreciation();
		}
		return true;

	case Index_Classe:
		{
			value = bottle.getClasse();
		}
		return true;

	case Index_Producteur:
		{
			value = bottle.getProducteur();
		}
		return true;

	case Index_Cepage:
		{
			value = bottle.getCepage();
		}
		return true;

	case Index_Achat:
		{
			PDate date;
			date = bottle.getDateAchat();
			date.toString(value);
            if (value == "Date")
                value = "";
		}
		return true;

	case Index_Lieu_d_achat:
		{
			value = bottle.getLieuAchat();
		}
		return true;

	case Index_Prix:
		{
			value = bottle.getPrix();
		}
		return true;

	case Index_Casier:
		{
			value = bottle.getCasier();
		}
		return true;

	case Index_Commentaire:
		{
			value = bottle.getCommentaire();
		}
		return true;

	}

	// It's an event
	if (index > Index_Event)
	{
		nb = index - Index_Event;
		Boolean type = nb % 2;
		nb = (nb-type)/2;
		const PCollection& coll = bottle.getJournal();
		if (nb >= coll.getSize())
		{
			PString str;
			str.print("The number for event '%d' is more or equal to the number in the bottle '%d'", nb, coll.getSize());
			logLine(str.data());
			return false;
		}
		const PJournalEvent* event = (const PJournalEvent*)coll.getAt(nb);

		if (type == 0) // date
			event->getDate().toString(value);
		else
			value = event->getNote();

	}

	return false;
}

