

#include "pcsvfilemanager.h"




PCsvFileManager::PCsvFileManager()
	:whereToPut_(0)
{
}
PCsvFileManager::~PCsvFileManager()
{
}

//----------------------------------------------------------
Boolean PCsvFileManager::open(const PString& str)
{
	if (!file.Open(str.data(), CFile::modeRead))
		return false;

	return true;
}

//----------------------------------------------------------
Boolean PCsvFileManager::getNextLine(CStringArray& line)
{
	line.RemoveAll();

	CString token;
	char c;
	Boolean eol = false;
	Boolean inField = false;

	while(!eol)
	{

		if (!get(c))
			return false;


		if (inField && c != '"')
		{
			token += c;
		}
		else
		{

			switch(c)
			{
			case ',':
			case ';':
				line.Add(token);
				token = "";
				break;

			case '"':
				inField = !inField;
				break;

			case 13:
				{
					if (!get(c))
						return false;
					if (c != 10)
						put(c);
				}
			case 10:
				line.Add(token);
				eol = true;
				break;

			default:
				token += c;
			};
		}

	}

	return true;
}

//----------------------------------------------------------
Boolean PCsvFileManager::setNextLine(CStringArray& line)
{
	return false;
	return true;
}

void PCsvFileManager::put(char c)
{
	backBuffer_[whereToPut_] = c;
	whereToPut_++;
}

Boolean PCsvFileManager::get(char& c)
{
	if (whereToPut_>0)
	{
		c = backBuffer_[whereToPut_];
		whereToPut_--;
		return true;
	}

	if ( 1!= file.Read(&c, 1) )
		return false;

	return true;
}

