
#ifndef PMemBufferINCLUDED
#define PMemBufferINCLUDED


#include "../cavist/global.h"


class PDatabase;
class PString;

class PMemBuffer
{

	friend class PDatabase;

public:

	PMemBuffer();
	PMemBuffer(VoidHandle handle);
	~PMemBuffer();

	// Common
	void reset();

	// InBuffer
	void append(const char* data, long len);

	// OutBuffer
	void get(char* data, long len);
	void get(PString& str);


	void lock();
	void unlock();

	void setHandle(VoidHandle h)	{ handle_ = h; };
	VoidHandle getHandle()			{ return handle_; };


private:

	void allocNewLen(long newLen);


	// Data
	long allocSize_;
	long dataLen_;
	long index_;
	char* data_;

	VoidHandle handle_;

};

PMemBuffer& operator>>(PMemBuffer& buff, float& f);
PMemBuffer& operator<<(PMemBuffer& buff, float f);

PMemBuffer& operator>>(PMemBuffer& buff, long& val);
PMemBuffer& operator<<(PMemBuffer& buff, long val);

PMemBuffer& operator>>(PMemBuffer& buff, char& c);
PMemBuffer& operator<<(PMemBuffer& buff, char c);

PMemBuffer& operator>>(PMemBuffer& buff, short& c);
PMemBuffer& operator<<(PMemBuffer& buff, short c);

#endif

