

#ifndef PDatabaseFileINCLUDED
#define PDatabaseFileINCLUDED


#include "stdafx.h"


#include "../cavist/pstring.h"
#include "../cavist/pcollection.h"
#include "../cavist/pcollectable.h"



class PFileRecord;
class PDatabaseFile
{

public:

	PDatabaseFile();
	~PDatabaseFile();

	Boolean read(PCollection& coll, const PString& name);
	Boolean write(PCollection& coll, const PString& name);


private:

	BYTE readByte(CFile& file);
	short readShort(CFile& file);
	long readLong(CFile& file);
	Boolean readString(CFile& file, char* buf, long nb);
	
	Boolean writeByte(CFile& file, BYTE b);
	Boolean writeShort(CFile& file, short s);
	Boolean writeLong(CFile& file, long l);
	Boolean writeString(CFile& file, char* buf, long nb);
	Boolean writeString(CFile& file, char* buf);

	void readRecord(CFile& file, PFileRecord* rec);

	void writeRecordDef(CFile& file, long, BYTE, char*);
	void writeRecordData(CFile& file, PRecord& rec);


	PString fileName_;

	// Header
	char name_[33];
	short attributes_;
	short version_;
	long creationDate_;
	long modificationDate_;
	long lastBackupDate_;
	long modificationNumber_;
	long appInfoID_;
	long sortInfoID_;
	char type_[5];
	char creator_[5];
	long uniqueIDSeed_;

	// Record
	long nextRecordListID_;


};


class PFileRecord : public PCollectable
{

	friend class PDatabaseFile;

public:

	PFileRecord();
	~PFileRecord();

	char* getData() { return data_; };
	long getLength() { return localChunkID_; };

	void setData(char* data, long len);


private:

	long localChunkID_;
	BYTE attributes_;
	char uniqueID_[3];

  char* data_;

};

#endif


